<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta name="description" content="Play MAME on your TV Arcade Monitor or Fixed Frequency Monitor">
<meta name="keywords" content="advancemame advancemenu advancecd advanceboot makebootfat advance advmame advcd advmenu advcomp mame mess linux scale2x arcade retrogame tv monitor control play coinop cabinet retrogaming">
<meta name="author" content="Andrea Mazzoleni">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="stylesheet" type="text/css" href="style.css">
<title>Advance Projects</title>

<!-- Google Analytics 4 -->
<!-- Google tag (gtag.js) -->
<script async src="https://www.googletagmanager.com/gtag/js?id=G-JE7ZVT424T"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'G-JE7ZVT424T');
</script>

<!-- Google Universal Analytics -->
<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-21967501-3']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>
</head>
<body>
<div id="header">
<img src="index.jpg" width="1200" height="150" alt="Title">
</div>
<div id="menu">
<a href="/">About</a>
<a href="download">Download</a>
<a href="doc">Documentation</a>
<a href="support">Support</a>
<a href="forum">Forum</a>
<a href="history">History</a>
<a href="cost">Cost</a>
<a href="video-link">Video</a>
<a href="authors">Authors</a>
</div>
<div id="main">


<p>
A cost estimation of the Advance Projects.
</p>

<p>
This is a cost estimation of the Advance Projects
generated using the SLOCCount program by David A. Wheeler from :
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="2"><tr><td width="5%"></td><td width="95%">
<a href="http://www.dwheeler.com/sloccount/">http://www.dwheeler.com/sloccount/</a>
<br>
</td></tr></table>
<p>
Only the specifically written for the Advance project are present
in this estimation. The sources imported from other projects,
data files, and automatically generated files are excluded from the
estimation.
<p>
A SLOC is a physical Source Line of Code also called "non-blank,
non-comment line".
<h2> 
Totals
</h2>
<pre>
Total Physical Source Lines of Code (SLOC)                = 126,714
Development Effort Estimate, Person-Years (Person-Months) = 19.77 (237.29)
Schedule Estimate, Years (Months)                         = 1.66 (19.98)
Estimated Average Number of Developers (Effort/Schedule)  = 11.88
Total Estimated Cost to Develop                           = $ 2,671,244
</pre>
<p>
The estimate is computed with the Intermediate COCOMO model in
"Organic" mode with an effort factor of 1.47. The effort factor is
computed from the default value 2.3 with the following application
cost drivers:
<p>
<pre>
Required software reliability          0.88 (Low)
Database size                          0.94 (Low)
Execution time constraint              1.11 (High)
</pre>
<p>
and with the following common environment cost drivers:
<p>
<pre>
Virtual machine volatility             0.87 (Low)
Use of "modern" programming practices  0.82 (Very High)
</pre>
<p>
All the other cost drivers were considered Nominal (1.0).
The analysts/programmers capability and experience were
intentionally considered nominal.
<p>
You may be surprised by the high cost estimates, but note that they are
supposed for a typical software development company. These include
design, coding, testing, documentation (both for users and for programmers),
and a wrap rate for corporate overhead (to cover facilities, equipment,
accounting, and so on). Many programmers forget these other costs and
are shocked by the high figures.
<p>
The Advance project, as hobbyist project, has no corporate overhead.
<h2> 
Projects
</h2>
<pre>
SLOC    Project                 SLOC-by-Language
91814   advancemame-0.86.0-diff ansic=89137,cpp=2264,yacc=211,lex=114,sh=88
13709   advancemenu-2.3.8       cpp=13709
7008    advancecomp-1.12        cpp=6064,ansic=858,sh=86
6695    advancecab-1.1.4        ansic=6140,asm=555
5032    advancescan-1.10        cpp=4930,ansic=102
2456    makebootfat-1.1         ansic=2311,asm=131,sh=14
</pre>
<h2> 
Directories
</h2>
<pre>
SLOC    Directory       SLOC-by-Language
20396   osd             ansic=20071,yacc=211,lex=114
17453   lib             ansic=17453
14487   blit            ansic=14487
13709   menu            cpp=13709
11967   dos             ansic=11967
10110   linux           ansic=10110
7008    comp            cpp=6064,ansic=858,sh=86
5032    scan            cpp=4930,ansic=102
3683    card            ansic=3683
3120    svgalib         ansic=3032,sh=88
2538    v               ansic=2538
2456    makebootfat     ansic=2311,asm=131,sh=14
1952    sdl             ansic=1952
1835    tsr             ansic=1464,asm=371
1621    windows         ansic=1621
1487    cfg             ansic=1487
1263    d2              cpp=1263
1057    vbe             ansic=986,asm=71
1051    vbe32           ansic=1051
1043    vbew            ansic=1043
1001    line            cpp=1001
775     vga             ansic=662,asm=113
529     videow          ansic=529
292     video           ansic=292
197     j               ansic=197
156     s               ansic=156
155     k               ansic=155
141     m               ansic=141
87      i               ansic=87
66      portio          ansic=66
47      off             ansic=47
</pre>
<h2> 
Languages
</h2>
<pre>
Laguange       SLOC
ansic:        98548 (77.77%)
cpp:          26967 (21.28%)
asm:            686 (0.54%)
yacc:           211 (0.17%)
sh:             188 (0.15%)
lex:            114 (0.09%)
</pre>


</div>

<div id="footer">

<div class="column">
<span class="bold">Donate with</span>
<br>
<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=amadvance%40gmail%2ecom&lc=US&item_name=AdvanceMAME&no_note=0&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHostedGuest"><img src="paypal.png" width="160" height="60" alt="PayPal"></a>
</div>

<div class="column">
<span class="bold">Find other resources at</span>
<br>
<a href="https://github.com/amadvance/advancemame/"><img src="github.png" width="160" height="60" alt="GitHub"></a>
<a href="http://sourceforge.net/projects/advancemame/"><img src="sourceforge.png" width="115" height="60" alt="SourceForge"></a>
</div>

</div>
</body>
</html>




